=== debian/changelog ===
postgis (2.1.4+dfsg-3+deb8u1) jessie-security; urgency=medium

  * Non-maintainer upload by the LTS Team.
  * CVE-2017-18359: denial of service via crafted ST_AsX3D function input

 -- Emilio Pozuelo Monfort <pochu@debian.org>  Thu, 31 Jan 2019 18:24:33 +0100

postgis (2.1.4+dfsg-3) unstable; urgency=high

  * Add patch geojson-fix-3094.patch, back-ported from the 2.1.7 release,
    to fix a crash of the database backend process when given invalid
    GeoJSON data.

 -- Markus Wanner <markus@bluegap.ch>  Mon, 30 Mar 2015 19:40:22 +0200

postgis (2.1.4+dfsg-2) unstable; urgency=medium

  * Add Dutch translation by Frans Spiesschaert. Closes: #765409.
  * Bump S-V: no changes required.

 -- Markus Wanner <markus@bluegap.ch>  Wed, 15 Oct 2014 10:58:52 +0200

postgis (2.1.4+dfsg-1) unstable; urgency=medium

  [ Paulo Flabiano Smorigo ]
  * add -lm for liblwgeom to avoid linkage problem.
  * enable ppc64el.
    (closes: #759505)

  [ Bas Couwenberg ]
  * Add Swedish translation by Martin Bagge. Closes: #761975.
  * Add strip-invalid-whitespace-in-pom.patch to fix mh_cleanpom failure.
  * Update copyright file.
  * Add patch to fix FTBFS on hurd-i386.

  [ Markus Wanner ]
  * New upstream release, 2.1.4. Adapt packaging to the new version.
  * Drop patches debian-versions, fix-armel, use-json-c, and
    postgresql-9.4-fixes.patch, these should be fixed upstream.
  * Refresh patches use-debian-maven, honor-build-flags, and
    enable-ppc64el.patch.
  * Add patch correct-java-version.patch.

 -- Markus Wanner <markus@bluegap.ch>  Sun, 21 Sep 2014 19:39:46 +0200
