## postgis 2.1.5+dfsg

=== debian/changelog ===
postgis (2.1.5+dfsg-1~exp2ubuntu1) vivid; urgency=high

  * SECURITY UPDATE: crash of the database backend process when given
    invalid GeoJSON data (LP: #1438875)
    - debian/patches/geojson-fix-3094.patch: back-ported from the 2.1.7
      release, taken from debian patch by Markus Wanner.
    - No CVE number

 -- Johan Van de Wauw <johan.vandewauw@gmail.com>  Wed, 01 Apr 2015 19:53:13 +0200

postgis (2.1.5+dfsg-1~exp2build1) vivid; urgency=medium

  * No-change rebuild for the libgdal-dev 1.11.2 transition.

 -- Adam Conrad <adconrad@ubuntu.com>  Wed, 18 Mar 2015 01:06:20 -0600

postgis (2.1.5+dfsg-1~exp2) experimental; urgency=medium

  * Update symbols for liblwgeom-2.1.5.
  * Update Homepage URL from postgis.refractions.net to postgis.net.
  * Update my email to use @debian.org address.
  * Add build dependency on openjdk-7-jdk | java7-sdk required to build
    libpostgis-java. OpenJDK 7 is not yet available on GNU/Hurd.
  * GNU/Hurd doesn't implement semaphores; skip regress tests on hurd-*.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 08 Feb 2015 21:41:31 +0100

postgis (2.1.5+dfsg-1~exp1) experimental; urgency=medium

  [ Markus Wanner ]
  * Downgrade the recommends on postgis to a suggestion, so we don't ever
    recommend all the way through to another PostgreSQL major version,
    when installing a specific postgresql-X.Y-postgis-2.1 package.

  [ Bas Couwenberg ]
  * New upstream release.
  * Add upstream metadata.
  * Add Brazilian translation by José de Figueiredo. Closes: #771782.
  * Fix get-orig-source path in watch file.
  * Update copyright file, changes:
    - Update copyright years
    - Change config.{sub,guess} license to GPL-3+ with Autoconf exception
    - Remove {extensions,raster}/Makefile, no longer included.
  * Drop enable-ppc64el.patch, applied upstream. Refresh remaining patches.

 -- Bas Couwenberg <sebastic@xs4all.nl>  Wed, 24 Dec 2014 14:49:02 +0100
