=== debian/control ===
--- 
+++ 
@@ -1,10 +1,11 @@
 Source: postgis
 Section: misc
 Priority: optional
-Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
 Uploaders: Stephen Frost <sfrost@debian.org>, Francesco Paolo
  Lovergine <frankie@debian.org>, Markus Wanner <markus@bluegap.ch>,
- Bas Couwenberg <sebastic@xs4all.nl>
+ Bas Couwenberg <sebastic@debian.org>
 Build-Depends: debhelper (>= 9), po-debconf,
  dpkg-dev (>= 1.16.1~), autotools-dev, dh-autoreconf, autoconf2.13,
  flex, bison, rdfind, libgeos-dev (>= 3.3),
@@ -14,14 +15,14 @@
  libgtk2.0-dev, libgdal-dev (>= 1.9.0~) | libgdal1-dev (>= 1.9.0~),
  postgresql-server-dev-all, postgresql-common (>= 148~), postgresql,
  maven-repo-helper
-Build-Depends-Indep: default-jdk,
+Build-Depends-Indep: default-jdk, openjdk-7-jdk | java7-sdk,
  libpostgresql-jdbc-java, fastjar, libjts-java (>= 1.7), maven2,
  libmaven-clean-plugin-java, libmaven-jar-plugin-java,
  libsurefire-java, libmaven-compiler-plugin-java,
  libmaven-resources-plugin-java,
  libmaven-javadoc-plugin-java
 Standards-Version: 3.9.6
-Homepage: http://postgis.refractions.net/
+Homepage: http://postgis.net/
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-grass/postgis.git
 Vcs-Git: git://anonscm.debian.org/pkg-grass/postgis.git
 
@@ -86,7 +87,7 @@
  .
  This package contains the documentation for the JDBC support for PostGIS.
 
-Package: liblwgeom-2.1.4
+Package: liblwgeom-2.1.5
 Architecture: any
 Section: libs
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -106,7 +107,7 @@
 Architecture: any
 Section: libdevel
 Depends: ${misc:Depends},
- liblwgeom-2.1.4 (= ${binary:Version})
+ liblwgeom-2.1.5 (= ${binary:Version})
 Breaks: postgis (<< 2.0.0)
 Description: PostGIS "Lightweight Geometry" library - Development files
  PostGIS adds support for geographic objects to the PostgreSQL
@@ -123,9 +124,10 @@
 
 Package: postgresql-9.4-postgis-2.1
 Depends: ${shlibs:Depends}, postgresql-9.4,
- postgresql-9.4-postgis-scripts, liblwgeom-2.1.4,
+ postgresql-9.4-postgis-scripts, liblwgeom-2.1.5,
  ${misc:Depends}
-Recommends: postgis, postgresql-contrib-9.4
+Recommends: postgresql-contrib-9.4
+Suggests: postgis
 Breaks: postgis (<< 1.2.1)
 Architecture: any
 Description: Geographic objects support for PostgreSQL 9.4
